test mbuf attach
[dpdk.git] / devtools / check-abi.sh
1 #!/bin/sh -e
2 # SPDX-License-Identifier: BSD-3-Clause
3 # Copyright (c) 2019 Red Hat, Inc.
4
5 if [ $# != 2 ] && [ $# != 3 ]; then
6         echo "Usage: $0 refdir newdir [warnonly]"
7         exit 1
8 fi
9
10 refdir=$1
11 newdir=$2
12 warnonly=${3:-}
13 ABIDIFF_OPTIONS="--suppr $(dirname $0)/libabigail.abignore --no-added-syms"
14
15 if [ ! -d $refdir ]; then
16         echo "Error: reference directory '$refdir' does not exist."
17         exit 1
18 fi
19 incdir=$(find $refdir -type d -a -name include)
20 if [ -z "$incdir" ] || [ ! -e "$incdir" ]; then
21         echo "WARNING: could not identify a include directory for $refdir, expect false positives..."
22 else
23         ABIDIFF_OPTIONS="$ABIDIFF_OPTIONS --headers-dir1 $incdir"
24 fi
25
26 if [ ! -d $newdir ]; then
27         echo "Error: directory to check '$newdir' does not exist."
28         exit 1
29 fi
30 incdir2=$(find $newdir -type d -a -name include)
31 if [ -z "$incdir2" ] || [ ! -e "$incdir2" ]; then
32         echo "WARNING: could not identify a include directory for $newdir, expect false positives..."
33 else
34         ABIDIFF_OPTIONS="$ABIDIFF_OPTIONS --headers-dir2 $incdir2"
35 fi
36
37 error=
38 for dump in $(find $refdir -name "*.dump"); do
39         name=$(basename $dump)
40         # skip glue drivers, example librte_pmd_mlx5_glue.dump
41         # We can't rely on a suppression rule for now:
42         # https://sourceware.org/bugzilla/show_bug.cgi?id=25480
43         if grep -qE "\<soname='[^']*_glue\.so\.[^']*'" $dump; then
44                 echo "Skipped glue library $name."
45                 continue
46         fi
47         dump2=$(find $newdir -name $name)
48         if [ -z "$dump2" ] || [ ! -e "$dump2" ]; then
49                 echo "Error: can't find $name in $newdir"
50                 error=1
51                 continue
52         fi
53         abidiff $ABIDIFF_OPTIONS $dump $dump2 || {
54                 abiret=$?
55                 echo "Error: ABI issue reported for 'abidiff $ABIDIFF_OPTIONS $dump $dump2'"
56                 error=1
57                 echo
58                 if [ $(($abiret & 3)) -ne 0 ]; then
59                         echo "ABIDIFF_ERROR|ABIDIFF_USAGE_ERROR, this could be a script or environment issue."
60                 fi
61                 if [ $(($abiret & 4)) -ne 0 ]; then
62                         echo "ABIDIFF_ABI_CHANGE, this change requires a review (abidiff flagged this as a potential issue)."
63                 fi
64                 if [ $(($abiret & 8)) -ne 0 ]; then
65                         echo "ABIDIFF_ABI_INCOMPATIBLE_CHANGE, this change breaks the ABI."
66                 fi
67                 echo
68         }
69 done
70
71 [ -z "$error" ] || [ -n "$warnonly" ]